#!/bin/sh
set -x

if test `uname` = Plan9; then
    export MYR_MUSE=`pwd`/muse/6.out
    export MYR_MC=`pwd`/6/6.out
    export MYR_RT=`pwd`/rt/_myrrt.6
else
    export MYR_MUSE=`pwd`/muse/muse
    export MYR_MC=`pwd`/6/6m
    export MYR_RT=`pwd`/rt/_myrrt.o
fi

./mbldwrap.sh
cp mbld/mbld xmbld
./xmbld clean

# The generated shell script should be a compatible bourne
# shell script.
bootscript=mk/bootstrap/bootstrap+`uname -s`-`uname -m`.sh
echo '#!/bin/sh' > $bootscript
echo '# This script is generated by genbootstrap.sh' >> $bootscript
echo '# to regenerate, run "make bootstrap"' >> $bootscript
echo 'pwd=`pwd`' >> $bootscript
./xmbld -Bnone mbld:mbld | \
    sed "s:^\\(.*\\)/[^/]*\.\.\.:	cd \$pwd/\\1:g" | \
    sed "s:`pwd`:\$pwd:g" | \
    grep '^	' | \
    sed 's/.*/echo & \&\& & \&\&\\/' | \
    tee -a $bootscript
echo 'true' >> $bootscript
chmod +x $bootscript
rm ./xmbld
